// edge.h

#ifndef edge_h___
#define edge_h___

#include "node.h"
#include "error_handler.h"
#include "user_types.h"

#include <string>
#include <list>

using std::string;
using std::list;

//------------------------------------------------------------------------------
class Edge
{
private:
//instance
Node node_;

// membervariable
  string edge_name_;
  string start_node_name_;
  string end_node_name_;
  uint32 weight_; 

// methodes
  void setEdgeName(string edge_name);   
  void setStartNodeName(string start_node_name);
  void setEndNodeName(string end_node_name);
  void setWeight(int32 weight);

  
public:
//constructor
  Edge();
  virtual ~Edge();

//methodes
  string getEdgeName() const;
  string getStartNodeName() const;
  string getEndNodeName() const;
  uint32 getWeight() const;
  
  void setEdge(string start_node_name, string end_node_name,
               string edge_name, uint32 weight);
};

#endif
