// error_handler.cpp
#include "error_handler.h"

#include <iostream>

using std::cerr;
using std::endl;

//------------------------------------------------------------------------------
// error, if the command is not known
//

void ErrorHandler::unknownCommand() const
{
  cerr << "error: unknown command" << endl;
}

//------------------------------------------------------------------------------
// error, if the node, which you want to create is already existing
//

void ErrorHandler::nodeAlreadyExisting() const
{
  cerr << "error: node already existing" << endl;
}

//------------------------------------------------------------------------------
// error, the name of the node is missing after 'add node' or 'delete node' 
//

void ErrorHandler::nameOfNodeMissing() const
{
     cerr << "error: name of node is missing" << endl;
}

//------------------------------------------------------------------------------
// error, no such node in graph
//

void ErrorHandler::nodeNotExisting() const
{
     cerr << "error: no such node existing" << endl;
}

//------------------------------------------------------------------------------
// error, parameter weight is missing
//

void ErrorHandler::missingWeight() const
{
     cerr << "error: weight of edge is missing" << endl;
}

//------------------------------------------------------------------------------
// error, parameter weight of edge is wrong
//

void ErrorHandler::wrongWeightOfEdge() const
{
     cerr << "error: weight of edge is wrong" << endl;     
}

//------------------------------------------------------------------------------
// error, parameter is missing
//

void ErrorHandler::nameOfEdgeMissing() const
{
     cerr << "error: name of edge is missing" << endl;
}

//------------------------------------------------------------------------------
// error, parameter is missing
//

void ErrorHandler::missingParameter() const
{
     cerr << "error: parameter missing" << endl;
}

//------------------------------------------------------------------------------
// error, parameter is missing
//

void ErrorHandler::edgeAlreadyExisting() const
{
     cerr << "error: edge already existing" << endl;
}
