// error_handler.h - functions to handle errors

#ifndef error_handler_h___
#define error_handler_h___

#include "user_types.h"


//------------------------------------------------------------------------------
// The class Errorhandling exists of several methods. The methods are used to
// get the error massages on the screen.
//

class ErrorHandler
{
public:
// Methods to print out the different errors

// This method prints out an error if the command is not known
  void unknownCommand() const;
  
// This method prints out an error if the node already exists
  void nodeAlreadyExisting() const;
  
// This method prints out an error if the parameters after the commands
// 'add node' or 'delete node' are missing
  void nameOfNodeMissing() const;
  
// This method prints out an error if the node doesn't exist
  void nodeNotExisting() const;
  
// This method prints out an error if the parameter weight is missing
  void missingWeight() const;
  
// This method prints out an error if the edge has a wrong weight
  void wrongWeightOfEdge() const;
  
// This method prints out an error if there are no parameters
  void nameOfEdgeMissing() const;
  
// 
  void missingParameter() const;
  
//
  void edgeAlreadyExisting() const;
};

#endif
