//graph.cpp

#include "graph.h"
#include "edge.h"
#include "node.h"
#include "output_handler.h"
#include "user_types.h"

#include <string>

using std::string;

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//constructor
Graph::Graph() : graph_(0), node_list_(0)
{
  //nothing to do
}

Graph::~Graph()
{
  graph_.clear();
}


//--------------------------------------------------------------------------
//
void Graph::setGraphEdge(string start_node_name, string end_node_name,
             string edge_name, uint32 weight)
{
  ///list<Edge>::iterator insertion_iterator = graph_.end();
  //*insertion_iterator.setEdge(start_node_name, end_node_name,
    //         edge_name, weight);
  graph_[graph_.size()+1].setEdge(start_node_name, end_node_name,
            edge_name, weight);
}


//--------------------------------------------------------------------------
//
void Graph::deleteGraphEdge(string edge_name)
{
  uint32 counter = 0;    
  vector<Edge>::iterator delete_iterator = graph_.begin();
  while(delete_iterator != graph_.end())
  {
    if(graph_[counter].getEdgeName() == edge_name)
    {
        graph_.erase(delete_iterator);
    }
    counter++;
  }  
}


//--------------------------------------------------------------------------
//
void Graph::setGraphNode(string node_name)
{
  node_graph_.createNode(node_name);
}


//--------------------------------------------------------------------------
//
void Graph::deleteGraphNode(string node_name)
{
  node_graph_.deleteNode(node_name);
}


//--------------------------------------------------------------------------
//
void Graph::showGraph(string start_node_name)
{
  string end_node_name = edge_graph_.getEndNodeName();
  string edge_name = edge_graph_.getEdgeName();
  uint32 weight = edge_graph_.getWeight();
  output_graph_.showGraph(start_node_name, end_node_name, edge_name, weight);
}




//--------------------------------------------------------------------------
//
bool Graph::doesNodeExist(string node_name)
{
  return(node_graph_.doesNodeExist(node_name));    
}


//--------------------------------------------------------------------------
//
bool Graph::doesEdgeWithStartNodeExist(string start_node_name, string edge_name)
{
  for(uint32 i = 0; i < graph_.size(); i++)
  {
    if(graph_[i].getEdgeName() == edge_name && 
       graph_[i].getStartNodeName() == start_node_name)
       return(true);
  }
  return(false);  
}

