// graph.h
#ifndef graph_h___
#define graph_h___

#include "node.h"
#include "edge.h"
#include "output_handler.h"
#include "user_types.h"
#include <string>
#include <vector>
#include <list>

using std::list;
using std::string;
using std::vector;

//------------------------------------------------------------------------------
class Graph
{
private:
//instances
  Node node_graph_; 
  Edge edge_graph_;
  Output_handler output_graph_;
  
//membervariable    
  vector<Edge> graph_;
  list<string> node_list_;
  
public:
//constructor
  Graph();
  virtual ~Graph();
  
//methodes
  void setGraphEdge(string start_node_name, string end_node_name,
                string edge_name, uint32 weight);
  void deleteGraphEdge(string edge_name);
  
  void setGraphNode(string node_name);
  void deleteGraphNode(string node_name);
 
  void showGraph(string start_node_name);

  bool doesNodeExist(string node_name);
  bool doesEdgeWithStartNodeExist(string start_node_name, string edge_name);
};

#endif
