// input_handler.cpp

#include "input_handler.h"
#include "error_handler.h"
#include "edge.h"
#include "node.h"
#include "user_types.h"


#include <stdlib.h>
#include <iostream>

using std::cin;
using std::cout;
using std::endl;
using std::atoi;


//------------------------------------------------------------------------------
// constructor
InputLineHandler::InputLineHandler():stop_run_loop_(true), input_("")
{

}


//------------------------------------------------------------------------------
// destuctor
InputLineHandler::~InputLineHandler()
{
  // nothing to do
}


//------------------------------------------------------------------------------
//
void InputLineHandler::run()
{
  for(;;)
  {
    if(!stop_run_loop_)
      break;

    cout << "workflow> ";

    input_ = "";
    if(getline(cin, input_).good())
    {

    if((input_.compare(0,4, "quit") == 0) && (!input_[4]))
    {
      stop_run_loop_ = false;           //exit programm
//      if(path_seeker_.getIsInitialized())
//      path_seeker_.deletePathMatrix();  // delete the calcualated path
//      if(labyrinth_.getIsInitialized())
//      labyrinth_.deleteMatrix();        // delete the matrix
    }
    
    else if(input_.compare(0,9, "add node ") == 0)
           readNodeParameters();  
    //else if((input_.compare(0,8, "add node") == 0))
      //     error_input_handler_.nameOfNodeMissing();             


    else if(input_.compare(0,12, "delete node ") == 0)            // delete node
           readDeleteNodeParameters();
    //else if((input_.compare(0,11, "delete node") == 0))
      //     error_input_handler_.nameOfNodeMissing();
           
           
    else if((input_.compare(0,9, "add edge ") == 0))
           readEdgeParameters();
    //else if((input_.compare(0,8, "add edge") == 0))
      //     error_input_handler_.nameOfEdgeMissing();
           
           
    else if(input_.compare(0,12, "delete edge ") == 0)            // delete edge
           cout << "Kante lschen" << endl;
    //else if((input_.compare(0,11, "delete edge") == 0))
      //     error_input_handler_.nameOfEdgeMissing();
           
           
    else if(input_.compare(0,5, "show ") == 0)
           readShowParameters();
    else if(input_.compare(0,4, "show") == 0)            // show all
           readAllStartNodeParameter();
    
    else 
         error_input_handler_.unknownCommand();
    }
  }  
}



//--------------------------------------------------------------------------
// readEdgeParameters : reads the parameters form the input and calls the 
// error_handler, if there are parameter missing oder wrong
void InputLineHandler::readEdgeParameters()
{
  string edge_parameter = input_.substr(9);
  uint32 end_index = 0;
  string edge_name = "";
  string start_node_name = "";
  string end_node_name = "";
  uint32 weight = 0;
  
  while(true)
  {

//----------------------------------------------
// search start_node_name
    end_index = edge_parameter.find(" ");
        
    if(end_index > sizeof(uint32) -1)
    {
       error_input_handler_.missingParameter();
       break;
    }
    
   // if(end_index > sizeof(uint32) -1)
     // start_node_name = edge_parameter;
      
    start_node_name.assign(edge_parameter, 0, end_index);    
    edge_parameter = edge_parameter.substr(end_index + 1);
    
    if(graph_input_handler_.doesNodeExist(start_node_name) == false)
      {
        error_input_handler_.nodeNotExisting();
        break;
      }     
//----------------------------------------------
// search end_node_name      
    end_index = edge_parameter.find(" ");
    
    if(end_index > sizeof(uint32) -1)
    {
       error_input_handler_.missingParameter();
       break;
    }
    
   // if(end_index > sizeof(uint32) -1)
     // end_node_name = edge_parameter;

    end_node_name.assign(edge_parameter, 0, end_index);
    edge_parameter = edge_parameter.substr(end_index + 1);
    
    if(graph_input_handler_.doesNodeExist(end_node_name) == false)
      {
        error_input_handler_.nodeNotExisting();
        break;
      }
//----------------------------------------------
// search edge_name
    end_index = edge_parameter.find(" ");
    
    if(end_index > sizeof(uint32) -1)
    {
       error_input_handler_.missingParameter();
       break;
    }
   // if(end_index > sizeof(uint32) -1)
     // edge_name = edge_parameter;      


    edge_name.assign(edge_parameter, 0, end_index);
    edge_parameter = edge_parameter.substr(end_index + 1);
    
    if(graph_input_handler_.doesEdgeWithStartNodeExist(start_node_name, edge_name) == true)
    {
      error_input_handler_.edgeAlreadyExisting();
      break;
    }    
        
//----------------------------------------------
// search weight    
    end_index = edge_parameter.find(" ");
    char* str = new char[edge_parameter.length()+1];
    for(uint32 counter = 0; counter < edge_parameter.length(); counter++)
      str[counter] =  edge_parameter.at(counter);
      
    if(end_index > sizeof(uint32) -1)
    {
      weight = atoi(str); 
      graph_input_handler_.setGraphEdge(start_node_name, end_node_name, 
                                        edge_name, weight);
      delete[] str;
      str = 0;
      break;
    }     
     
    weight = atoi(str);
    edge_parameter = edge_parameter.substr(end_index + 1);
    graph_input_handler_.setGraphEdge(start_node_name, end_node_name, 
                                      edge_name, weight);    
    delete[] str;
    str = 0;
  }       
}



//-----------------------------------------------------------------------
//
void InputLineHandler::readNodeParameters()
{
  string node_name = "";
  uint32 end_index = 0;    
  string node_parameter = input_.substr(9);
    
  while(true)
  {      
    end_index = node_parameter.find(" ");
    if(end_index > sizeof(uint32) -1)
    {
      node_name = node_parameter;
      node_parameter = node_parameter.substr(end_index + 1);  
      
      if(graph_input_handler_.doesNodeExist(node_name) == true)
      { 
        error_input_handler_.nodeAlreadyExisting();
        break;
      }    
      else 
      {
        graph_input_handler_.setGraphNode(node_name);   
        break;   
      }
    }    
    
    node_name.assign(node_parameter, 0, end_index);
    node_parameter = node_parameter.substr(end_index + 1);
    
    if(graph_input_handler_.doesNodeExist(node_name) == true)
    { 
      error_input_handler_.nodeAlreadyExisting();
      break;
    }
    else
      graph_input_handler_.setGraphNode(node_name); 
  }
}


//-----------------------------------------------------------------------
//
void InputLineHandler::readDeleteNodeParameters()
{
  string node_name = "";
  uint32 end_index = 0;    
  string node_parameter = input_.substr(12);

  while(true)
  {
    end_index = node_parameter.find(" ");
    if(end_index > sizeof(uint32) -1)
    {
      node_name = node_parameter;
      //node_parameter = node_parameter.substr(end_index + 1);  
      if(graph_input_handler_.doesNodeExist(node_name) == false)
      {
        error_input_handler_.nodeNotExisting();
        break;
      }    
      else 
      {
        graph_input_handler_.deleteGraphNode(node_name);
        break;   
      }
    }    
    
    node_name.assign(node_parameter, 0, end_index);
    node_parameter = node_parameter.substr(end_index + 1);        
    
    if(graph_input_handler_.doesNodeExist(node_name) == false)
    {
      error_input_handler_.nodeNotExisting();
      break;
    }
    else
      graph_input_handler_.deleteGraphNode(node_name);
  }
}


//-----------------------------------------------------------------------
//
void InputLineHandler::readShowParameters()
{
  string node_name = "";
  uint32 end_index = 0;    
  string node_parameter = input_.substr(5);
    
  while(true)
  {      
    end_index = node_parameter.find(" ");
    if(end_index > sizeof(uint32) -1)
    {
      node_name = node_parameter;
      //node_parameter = node_parameter.substr(end_index + 1);  
      
      if(graph_input_handler_.doesNodeExist(node_name) == false)
      { 
        error_input_handler_.nodeNotExisting();
        break;
      }    
      else 
      {
        graph_input_handler_.showGraph(node_name);
        break;   
      }
    }    
    
    node_name.assign(node_parameter, 0, end_index);
    node_parameter = node_parameter.substr(end_index + 1);
    
    if(graph_input_handler_.doesNodeExist(node_name) == false)
    { 
      error_input_handler_.nodeNotExisting();
      break;
    }
    else
      graph_input_handler_.showGraph(node_name);
  }
}


//-----------------------------------------------------------------------
//
void InputLineHandler::readAllStartNodeParameter()
{
  
}
