// node.cpp

#include "node.h"

#include <iostream>
#include <string>
#include <list>

using std::string;
using std::endl;
using std::cout;
using std::list;


//------------------------------------------------------------------------------
//constructor
Node::Node()
{
//nothing to do
}

Node::~Node()
{
  node_list_.clear();
}


//------------------------------------------------------------------------------
// implementation of node methodes

//------------------------------------------------------------------
// doesNodeExist : returns true, if node exists and returns false if
// node does not exist
bool Node::doesNodeExist(string node_name)
{
  list<string>::iterator insertion_iterator = node_list_.begin();
  while(insertion_iterator != node_list_.end())
  {
    if(node_name == *insertion_iterator++)   
    return(true);
  }
  return(false);
}


//------------------------------------------------------------------
// deleteNode : deletes node from the node_list if is on node_list
// and calls the error_handler, if not does not exist.
void Node::deleteNode(string node_name)
{
  list<string>::iterator insertion_iterator = node_list_.begin();
  while(insertion_iterator != node_list_.end())
  {
    if(node_name == *insertion_iterator)
    {  
        node_list_.erase(insertion_iterator);
        break;
    }    
      *insertion_iterator++;
  }
}


//------------------------------------------------------------------------------
// createNode :  creates a new node, if node does not exits
void Node::createNode(string node_name)
{
  node_list_.push_back(node_name);
}
